/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */
/* $Log:	display_detail.c,v $
 * Revision 1.3  93/01/02  20:53:33  jimj
 * Remove the Xw things and make
 * it just use Xaw text editor
 * 
 * Revision 1.2  92/12/31  23:49:11  jimj
 * Minor cleanup fixes 
 * 
 * Revision 1.1  1992/09/24  23:48:00  jimj
 * Initial revision
 *
 */
#include <sys/types.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/AsciiText.h>

extern char *data_all[];
static Widget detailedit;

/**  This procedure opens up the window and the scrollbar etc that 
 **  is associated with the window on top that displays all the
 **  packets in a general form
 **/

void create_display_detail(parent)
Widget parent;
{
     Arg wargs[7];

     XtSetArg(wargs[0], XtNtype, XawAsciiString);
     XtSetArg(wargs[1], XtNscrollVertical, XawtextScrollAlways);
     XtSetArg(wargs[2], XtNwrap, XawtextWrapLine);
     XtSetArg(wargs[3], XtNdisplayCaret, FALSE);
     XtSetArg(wargs[4], XtNstring, "James Jegers   jimj@cs.uwm.edu");

     detailedit = XtCreateManagedWidget("detailedit", asciiTextWidgetClass, 
     					 parent, wargs, 5);
}

draw_detail(position)
int position;
{
    char packet[5000], data[5000];
    Arg wargs[2];

    data[0] = '\0';

    	/*  Copy the packet cuz the routine changes it a bit */
    strcpy(packet, data_all[position]);

    whatis_detail(data, packet);

    XtSetArg(wargs[0], XtNstring, data);
    XtSetValues(detailedit, wargs, 1);
}

