/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */

/* $Log:	main.c,v $
 * Revision 1.3  93/01/02  23:35:29  jimj
 * fixed some more things reducing the amount
 * needed to run the Xw widgets
 * 
 * Revision 1.2  92/12/31  23:49:31  jimj
 * Some minor cleanups
 * 
 * Revision 1.1  1992/09/24  23:51:42  jimj
 * Initial revision
 *
 */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xutil.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <sys/types.h>
#include "version.h"

extern void filename_button();
extern Widget criteria_button();
extern void create_display_all();
extern void create_display_one();
static void quit_callback();
Widget toplevel;

main(argc, argv)
int argc;
char *argv[];
{
    Widget panel, displays, commands, wid;
    Arg wargs[2];

    	/*  Initialize the conversion routine */
    init_ip2real();
    	/*  Check something or other */ 
    init_checkether();

    toplevel = XtInitialize(argv[0], "Xnetanal", 
			    NULL, 0, &argc, argv);

    	/*  Make the window where you can select which packets to view */
    create_criteria_window();

    	/*  Load in the file from disk */
    load_file();

	/* Create the main screen, with all of it's parts */
    panel = XtCreateManagedWidget("panel", panedWidgetClass, toplevel, NULL,0);

    XtSetArg(wargs[0], XtNlabel, VERSIONMAIN);

    (void) XtCreateManagedWidget("title", labelWidgetClass, panel, wargs,1);

    commands = XtCreateManagedWidget("commands", boxWidgetClass, panel, NULL,0);

	/* Commands Quit button */
      XtSetArg(wargs[0], XtNlabel, "Quit");
      wid = XtCreateManagedWidget("quit", commandWidgetClass, commands, wargs, 1);
      XtAddCallback(wid, XtNcallback, quit_callback, NULL);

    	/*  Filename prompt, and editor */
      filename_button(commands);

    	/*  Redo selection criteria button */
      wid = criteria_button(commands);

    	/*  Make the displays which show the data */
    create_display_all(panel);
    create_display_detail(panel);
    create_display_hex(panel);

/**  This will put the data in the top widget and get everything
 **  else going in all the other widgets
 **/
    draw_all(); 

    XtRealizeWidget(toplevel);

    XtMainLoop();
} /*  Main  */

static void quit_callback(w, client_data, call_data)
Widget w;
caddr_t client_data, call_data;
{
  exit(0);
}

