/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */

/* $Log:	wanted_packets.c,v $
 * Revision 1.2  92/12/31  23:55:42  jimj
 * Minor cleanup fixes
 * 
 * Revision 1.1  1992/09/24  23:51:42  jimj
 * Initial revision
 *
 */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h> 
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Box.h>
#include <sys/types.h>
#include "types.h"
#include "version.h"

extern Widget edit_one_line();
void wanted_packets();
void what_type();
static Widget from1, from2, to1, to2, fromip1, fromip2, toip1, toip2;
static Widget fromport1, fromport2, toport1, toport2;
static int want_type = ANY;

static int not_first = 0;
/*
 *  Look to see what was entered and then select just those packets 
 */
void wanted_packets()
{
   extern char *data_all[];
   extern int numpacketsread;
   extern int data_list[];
   extern int numpacketslist;
   int totaloop;

   numpacketslist = 0;
   for (totaloop = 0; totaloop < numpacketsread; totaloop++) {
	if (check_address(data_all[totaloop], from1, to1, from2, to2)) 
	     continue;

	if (check_hard_type(data_all[totaloop]) )
	     continue;

	if (check_ip(data_all[totaloop], fromip1, toip1, fromip2, toip2) )
	    continue;

	if (check_port(data_all[totaloop], fromport1, toport1,
					   fromport2, toport2) )
	    	    continue;

     		data_list[numpacketslist] = totaloop;
      		numpacketslist++;
    }

    printf("Selected %d packets.\n", numpacketslist);
    if (not_first++)
   	   draw_all();
}  /*  what packets the user wants to see */

check_address(packet, f1, t1, f2, t2)
char *packet;
Widget f1, t1, f2, t2;
{
   extern char *getlabel();

   char *a1 = getlabel(f1);
   char *b1 = getlabel(t1);
   char *a2 = getlabel(f2);
   char *b2 = getlabel(t2);

   if (!a1[0] && !b1[0]) {
      if (address(&packet[18], a2) || address(packet, b2))
    	return(1);
      else
  	return(0);
   }
   if (!a2[0] && !b2[0]) {
  	if (address(&packet[18], a1) || address(packet, b1))
	   return(1);
	else
	   return(0);
   }
   if ( (!address(&packet[18], a1) && !address(packet, b1)) || 
	(!address(&packet[18], a2) && !address(packet, b2)) ) 
	return(0);
   else
	return(1);
}

address(is, want)
u_char *is, *want;
{
   int loop;
   char newis[20];

   if(want[0] == 0)
	return(0);

   for (loop = 0; loop <= 17; loop++) 
      newis[loop] = is[loop];
   newis[17] = '\0';
   newis[2] = newis[5] = newis[8] =newis[11] = newis[14] = ':';

   return(strcmp(newis, want) );
}

	/*  Checks hardware type of packet */
check_hard_type(packet)
char *packet;
{
   if (want_type == ANY)
	return(0);
   if (want_type == ARP) {
       if (packet[36] == '0' && packet[37] == '8' && 
	   packet[39] == '0' && packet[40] == '6')
	        return(0);
       else
		return(1);
   }
   if (want_type == IP) {
       if (packet[36] == '0' && packet[37] == '8' && 
	   packet[39] == '0' && packet[40] == '0')
	        return(0);
       else
		return(1);
   }
      /*  If doesn't match the above, must have picked other  */
   if (packet[36] == '0' && packet[37] == '8' && 
       packet[39] == '0' && (packet[40] == '0' || packet[40] == '6') )
	        return(1);
       else
		return(0);
}

	/*  Check if the ip packet matches */

check_ip(packet, f1, t1, f2, t2)
char *packet;
Widget f1, t1, f2, t2;
{
   extern char *getlabel();

   char *a1 = getlabel(f1);
   char *b1 = getlabel(t1);
   char *a2 = getlabel(f2);
   char *b2 = getlabel(t2);

   if (!a1[0] && !b1[0]) {
      if (checkip_address(&packet[78], a2) || checkip_address(&packet[90], b2))
        return(1);
      else
        return(0);
   }
   if (!a2[0] && !b2[0]) {
        if (checkip_address(&packet[78], a1)|| checkip_address(&packet[90], b1))
           return(1);
        else
           return(0);
   }
   if ( (!checkip_address(&packet[78], a1) &&
	 !checkip_address(&packet[90], b1)) ||
        (!checkip_address(&packet[78], a2) &&
	 !checkip_address(&packet[90], b2)) )
        return(0);
   else
        return(1);
}
      
checkip_address(is, want)
char *is, *want;
{
   char newis[20];

   if (want[0] == 0)
	return(0);

   sprintf(newis, "%d.%d.%d.%d", (int) strtol(is, (char **) NULL, 16),
          (int) strtol(&is[3], (char **) NULL, 16),
          (int) strtol(&is[6], (char **) NULL, 16),
          (int) strtol(&is[9], (char **) NULL, 16)  );

   return(strcmp(newis, want) );
}

check_port(packet, f1, t1, f2, t2)
char *packet;
Widget f1, t1, f2, t2;
{
   extern char *getlabel();

   char *a1 = getlabel(f1);
   char *b1 = getlabel(t1);
   char *a2 = getlabel(f2);
   char *b2 = getlabel(t2);

   if (!a1[0] && !b1[0]) {
      if (checkp(&packet[102], a2) || checkp(&packet[108], b2))
        return(1);
      else
        return(0);
   }
   if (!a2[0] && !b2[0]) {
        if (checkp(&packet[102], a1)|| checkp(&packet[108], b1))
           return(1);
        else
           return(0);
   }
   if ( (!checkp(&packet[102], a1) && !checkp(&packet[108], b1)) ||
        (!checkp(&packet[102], a2) && !checkp(&packet[108], b2)) )
        return(0);
   else
        return(1);
}

checkp(is, want)
char *is, *want;
{
   char newis[8], port[6];

   if (want[0] == 0)
	return(0);

   newis[0] = is[0]; newis[1] = is[1]; 
   newis[2] = is[3]; newis[3] = is[4];
   newis[4] = '\0';

   sprintf(port, "%d", (int) strtol(newis, (char **) NULL, 16)  );
   return(strcmp(port, want) );
}

/* **********************************
 * Open up the selection window and put
 * All of the boxes in it for the user to 
 * enter stuff in 
 * **************************************
 */
create_criteria_window()
{
   extern Widget toplevel;
   Widget criteria, panel;
   Arg wargs[1];

   criteria = XtCreateApplicationShell("criteria", topLevelShellWidgetClass, 
   					NULL, 0);

	/*  Make rows to hold stuff */
   panel = XtCreateManagedWidget("criteria_pane", panedWidgetClass, criteria,
				wargs, 1);

   XtSetArg(wargs[0], XtNlabel, VERSIONSUB);
   (void) XtCreateManagedWidget("title", labelWidgetClass, panel, wargs,1);

   hardware_ether(panel);
   hardware_type(panel);
   ip_address(panel);
   port_number(panel);

   XtRealizeWidget(criteria);
}

/* *************************************
 *  Set up a section to enter the hardware
 *  ethernet address
 * ***************************************
 */
hardware_ether(parent)
Widget parent;
{
   Widget ether;
   Arg wargs[2];

   XtSetArg(wargs[0], XtNlabel, "Hardware address");
   XtCreateManagedWidget("hardwarelabel", labelWidgetClass, parent, wargs,1);

   ether = XtCreateManagedWidget("box", boxWidgetClass, parent, wargs, 0);
   
     XtSetArg(wargs[0], XtNlabel, "From");
     XtCreateManagedWidget("string", labelWidgetClass, ether, wargs,1);
     from1 = edit_one_line("from1", ether);
     XtCreateManagedWidget("string", labelWidgetClass, ether, wargs,1);
     from2 = edit_one_line("from2", ether);

     XtSetArg(wargs[0], XtNlabel, "To");
     XtCreateManagedWidget("string", labelWidgetClass, ether, wargs,1);
     to1 = edit_one_line("to1", ether);
     XtCreateManagedWidget("string", labelWidgetClass, ether, wargs,1);
     to2 = edit_one_line("to2", ether);
}

/* ************************************
 *  Section to enter the hardware 
 *  type.. IP, ARP, etc.
 * ******************************
 */
hardware_type(parent)
Widget parent;
{
   Arg wargs[2];
   Widget type, button;

   XtSetArg(wargs[0], XtNlabel, "Ethernet type");
   XtCreateManagedWidget("string", labelWidgetClass, parent, wargs, 1);

   type = XtCreateManagedWidget("rwcol", boxWidgetClass, parent, wargs, 0);

   XtSetArg(wargs[0], XtNlabel, "Any Type");
   button = XtCreateManagedWidget("but", commandWidgetClass, type,wargs,1);
   XtAddCallback(button, XtNcallback, what_type, (XtPointer) 0);

   XtSetArg(wargs[0], XtNlabel, "ARP");
   button = XtCreateManagedWidget("but", commandWidgetClass, type,wargs,1);
   XtAddCallback(button, XtNcallback, what_type, (XtPointer) 1);

   XtSetArg(wargs[0], XtNlabel, "IP");
   button = XtCreateManagedWidget("but", commandWidgetClass, type,wargs,1);
   XtAddCallback(button, XtNcallback, what_type, (XtPointer) 2);

   XtSetArg(wargs[0], XtNlabel, "Other");
   button = XtCreateManagedWidget("but", commandWidgetClass, type,wargs,1);
   XtAddCallback(button, XtNcallback, what_type, (XtPointer) 3);

}

/* **********************************
 *  If they push a type, register it
 * *********************************
 */
void what_type(w, which, call_data)
Widget w;
int which;
caddr_t call_data;
{
   if(which == 0)
	want_type = ANY;
   else if(which == 1)
	want_type = ARP;
   else if(which == 2)
	want_type = IP;
   else if (which == 3)
	want_type = OTHER;
   else
     printf("oh oh.. called with some strange number \n");
}

/* ******************************
 * Allow them to enter the ip
 * address. most commonly used
 * for IP packets
 * ***************************
 */
ip_address(parent)
Widget parent;
{
   Widget ip;
   Arg wargs[2];

   XtSetArg(wargs[0], XtNlabel, "IP address");
   XtCreateManagedWidget("string", labelWidgetClass, parent, wargs, 1);

   ip = XtCreateManagedWidget("rowcol", boxWidgetClass, parent, wargs, 0);
   
   XtSetArg(wargs[0], XtNlabel, "From");
   XtCreateManagedWidget("string", labelWidgetClass, ip, wargs,1);
   fromip1 = edit_one_line("fromip1", ip);
   XtCreateManagedWidget("string", labelWidgetClass, ip, wargs,1);
   fromip2 = edit_one_line("fromip2", ip);

   XtSetArg(wargs[0], XtNlabel, "To");
   XtCreateManagedWidget("string", labelWidgetClass, ip, wargs,1);
   toip1 = edit_one_line("toip1", ip);
   XtCreateManagedWidget("string", labelWidgetClass, ip, wargs,1);
   toip2 = edit_one_line("toip2", ip);
}

/* ******************************
 * Be able to select which IP
 * port number to view
 * **************************
 */
port_number(parent)
Widget parent;
{
   Widget port;
   Arg wargs[2];

   XtSetArg(wargs[0], XtNlabel, "Port #");
   XtCreateManagedWidget("string", labelWidgetClass, parent, wargs, 1);

   port = XtCreateManagedWidget("rowcol", boxWidgetClass, parent, wargs, 0);
   
   XtSetArg(wargs[0], XtNlabel, "From");
   XtCreateManagedWidget("string", labelWidgetClass, port, wargs,1);
   fromport1 = edit_one_line("fromport1", port);
   XtCreateManagedWidget("string", labelWidgetClass, port, wargs,1);
   fromport2 = edit_one_line("fromport2", port);

   XtSetArg(wargs[0], XtNlabel, "To");
   XtCreateManagedWidget("string", labelWidgetClass, port, wargs,1);
   toport1 = edit_one_line("toport1", port);
   XtCreateManagedWidget("string", labelWidgetClass, port, wargs,1);
   toport2 = edit_one_line("toport2", port);
}

/*  **********************************************
 *  Make a button in the main section that allows 
 *  the user to look at choices to pick which
 *  packets to look at
 *  **********************************************
 */
Widget criteria_button(parent)
Widget parent;
{
   Arg wargs[1];
   Widget w;
  
   XtSetArg(wargs[0], XtNlabel, "Redo Selection Criteria");
   w = XtCreateManagedWidget("criteria", commandWidgetClass, parent, 
				wargs, 1);
   XtAddCallback(w, XtNcallback,  wanted_packets, NULL);
   return(w);
}

