/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */
/* $Log:	whatis.c,v $
 * Revision 1.3  93/01/02  23:34:55  jimj
 * fixed to give the information back as one string
 * instead of many one line strings.
 * 
 * Revision 1.2  92/12/31  23:55:45  jimj
 * Minor cleanup fixes
 * 
 * Revision 1.1  1992/09/24  23:51:42  jimj
 * Initial revision
 *
 */

/*  This is the part of the program that actually does all
 *  the decoding of the packets into human terms
 */

#include <stdio.h>
#include <strings.h>
#include <sys/types.h>
#include "types.h"

char temp[30];

/*  This function figures out what the string should be
 *  that corresponds to one line in the overall view
 *  section.. The top section
 */

whatis_general(retstring, packet)
char *retstring;
char packet[];
{
   char string[20];
   int i;

   strcpy(retstring, "");
   ether2real(retstring, packet);
   strcat(retstring, "  ");
   ether2real(retstring, &(packet[18]));

   switch (ether_type(retstring, &packet[36])) {
	case IP:
		switch(ip_type(retstring, &packet[69])) {
			case TCP:
			case UDP:
			     strcat(retstring, " ");
			     port_type(retstring, &packet[102]);
			     strcat(retstring, "  ");
			     port_type(retstring, &packet[108]);
		} /*  ip switch */
   } /* ether Switch */
} /* whatis general */

whatis_detail(string, packet)
char *string;
char *packet;
{
   char tmpstring[100];
   char tmpstring2[100];
   int pos;


   strcpy(string, "----------  Ethernet Header  ----------\n");
   pos = strlen(string);
   strncat(string, packet, 17);
   string[pos+17] = '\0';
   strcat(string, "  Destination ");
   tmpstring[0] = '\0';
   ether2real(tmpstring, packet);
   strcat(string, tmpstring);
   strcat(string, "\n");

   pos = strlen(string);
   strncat(string, &packet[18], 17);
   string[pos+17] = '\0';
   strcat(string, "  Source      ");
   tmpstring[0] = '\0';
   ether2real(tmpstring, &packet[18]);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[36], 4);
   strcat(string, tmpstring);
   strcat(string, " Type ");
   switch (ether_type(string, &packet[36])) {
	case ARP:
		strcat(string, "\n");
		whatis_arp(string, &packet[42]);
		return;
		break;
	case IP:
		strcat(string, "\n");
		whatis_ip(string, &packet[42]);
		return;
		break;
	case OTHER:
		strcat(string, "\n");
		strcat(string, "----------  Unknown Header  ----------\n");
		return;
		break;
   } /* switch */
}

whatis_arp(string, packet)
char *string;
char *packet;
{
	char tmpstring[100];
	char tmpstring2[100];

	tmpstring2[0]  = '\0';

	strcat(string, "----------  Arp Header  ----------\n");

	strcat(string, "Format of hardware address ");
	tmpstring[0]  = '\0';
	copy(tmpstring, packet, 4);
	strcat(string, tmpstring);
	strcat(string, "\n");

	strcat(string, "Format of protocal address ");
	tmpstring[0]  = '\0';
	copy(tmpstring, &packet[6], 4);
	strcat(string, tmpstring);
	strcat(string, "\n");

	strcat(string, "Length of hardware address ");
	tmpstring[0]  = '\0';
	packet2int(tmpstring, &packet[12], 2);
	strcat(string, tmpstring);
	strcat(string, "\n");

	strcat(string, "Length of protocol address ");
	tmpstring[0]  = '\0';
	packet2int(tmpstring, &packet[15], 2);
	strcat(string, tmpstring);
	strcat(string, "\n");

	strcat(string, "One of: ");
	tmpstring[0]  = '\0';
	packet2int(tmpstring, &packet[18], 4);
	strcat(string, tmpstring);
	strcat(string, "\n");

	tmpstring[0]  = '\0';
	copy(tmpstring, &packet[24], 12);
	strcat(string, tmpstring);
	strcat(string, "  Sender hardware address ");
	tmpstring[0]  = '\0';
	ether2real(tmpstring, &packet[24]);
	strcat(string, tmpstring);
	strcat(string, "\n");

	tmpstring[0]  = '\0';
	copy(tmpstring, &packet[42], 8);
	strcat(string, tmpstring);
	strcat(string, "      Sender protocol address ");
	my2ip(tmpstring, &packet[42]);
	tmpstring2[0]  = '\0';
	ip2real(tmpstring2, tmpstring);
	strcat(string, tmpstring2);
	strcat(string, "\n");

	tmpstring[0]  = '\0';
	copy(tmpstring, &packet[54], 12);
	strcat(string, tmpstring);
	strcat(string, "  Target hardware address ");
	ether2real(string, &packet[54]);
	strcat(string, "\n");

	tmpstring[0]  = '\0';
	copy(tmpstring, &packet[72], 8);
	strcat(string, tmpstring);
	strcat(string, "      Target protocol address ");
	tmpstring[0]  = '\0';
	my2ip(tmpstring, &packet[72]);
	tmpstring2[0]  = '\0';
	ip2real(tmpstring2, tmpstring);
	strcat(string, tmpstring2);
	strcat(string, "\n");
}

whatis_ip(string, packet)
char *string;
char packet[];
{
   char tmpstring[100];
   char tmpstring2[100];
   int iptype;

   strcat(string, "----------  IP Header  ----------\n");

   strcat(string, "Header length ");
   tmpstring[0] = '\0';
   copy(tmpstring, packet, 1);
   strcat(string, tmpstring);
   strcat(string, ",  Version ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[1], 1);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Type of service ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[3], 2);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   strcat(string, "Total length ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[6], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   strcat(string, "Identification ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[12], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   strcat(string, "Fragment offset field ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[18], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Time to live ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[24], 2);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Protocol ");
   tmpstring[0] = '\0';
   iptype = ip_type(tmpstring, &packet[27]);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   strcat(string, "Checksum ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[30], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   tmpstring[0] = '\0';
   copy(tmpstring, &packet[36], 8);
   strcat(string, tmpstring);
   strcat(string, "  Source      Address ");
   tmpstring[0] = '\0';
   my2ip(tmpstring, &packet[36]);
   tmpstring2[0] = '\0';
   ip2real(tmpstring2, tmpstring);
   strcat(string, tmpstring2);
   strcat(string, "\n");

   tmpstring[0] = '\0';
   copy(tmpstring, &packet[48], 8);
   strcat(string, tmpstring);
   strcat(string, "  Destination Address ");
   tmpstring[0] = '\0';
   my2ip(tmpstring, &packet[48]);
   tmpstring2[0] = '\0';
   ip2real(tmpstring2, tmpstring);
   strcat(string, tmpstring2);
   strcat(string, "\n");

   switch (iptype) {
	case TCP:	
		whatis_tcp(string, &packet[60]);
		break;
	case ICMP:
		whatis_icmp(string, &packet[60]);
		break;
	case PUP:
		whatis_pup(string, &packet[60]);
		break;
	case UDP:
		whatis_udp(string, &packet[60]);
		break;
   } /* switch */
} 

whatis_pup(string, packet)
char *string;
char packet[];
{
   strcat(string, "----------  PUP Header  ----------\n");
}

whatis_udp(string, packet)
char *string;
char packet[];
{
   char tmpstring[100];

   strcat(string, "----------  UPD Header  ----------\n");
   strcat(string, "Source port ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, packet, 4);
   strcat(string, tmpstring);
   strcat(string, "\n");
   
   strcat(string, "Destination port ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[6], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "UDP length ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[12], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "UDP checksum ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[18], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "-----  Data  -----\n");
   packet2hexascii(string, &packet[24]);
}

whatis_tcp(string, packet)
char *string;
char packet[];
{
   char tmpstring[100];

   strcat(string, "----------  TCP Header  ----------\n");

   strcat(string, "Source Port ");
   tmpstring[0] = '\0';
   port_type(tmpstring, packet);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Destination Port ");
   tmpstring[0] = '\0';
   port_type(tmpstring, &packet[6]);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Sequence number ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[12], 8);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Acknowledgement number ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[24], 8);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Data Offset: ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[36], 2);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Flags ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[39], 2);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Window ");
   tmpstring[0] = '\0';
   packet2int(tmpstring, &packet[42], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Checksum ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[48], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "Urgent pointer ");
   tmpstring[0] = '\0';
   copy(tmpstring, &packet[54], 4);
   strcat(string, tmpstring);
   strcat(string, "\n");

   strcat(string, "-----  Data  -----\n");
   packet2hexascii(string, &packet[60]);
}

whatis_icmp(string, packet)
char *string;
char packet[];
{
   strcat(string, "----------  ICMP Header  ----------\n");
}

/*  transfer a couple characters from the packet list
 *  to a string, chopping out the spaces that are in the
 *  packet list.
 *  This code could be fixed.. lots of wasteful movements
 */

copy(retstring, givestring, num)
char *retstring, *givestring;
int num;
{
   char string[30];
   int ret = 0, st = 0;

   while (ret < num)  {
     string[ret] = givestring[st];
     ret++; st++;
     if (!( (st+1) % 3))
        st++;
   }
   string[ret] = '\0';
   strcat(retstring, string);
}

packet2int(retstring, packet, count)
char *retstring, packet[];
int count;
{
   char string[20];

   string[0] = '\0';

   copy(string, packet, count);
   sprintf(string, "%d", (int) strtol(string, (char **) NULL, 16)  );
   strcat(retstring, string);
}

/*  Return 1 if not equal  */
compare(s1, s2)
u_char s1[], s2[];
{
   int loop;

   for(loop = 0; loop < 17; loop++)
      if (s1[loop] != s2[loop])
        return(1);
   return(0);
}

