#include <InterViews/canvas.h> 
#include <InterViews/painter.h> 
#include <InterViews/sensor.h> 
#include <InterViews/perspective.h> 
#include <InterViews/box.h> 
#include <InterViews/message.h> 
#include <InterViews/border.h> 
#include <InterViews/menu.h> 
#include <InterViews/glue.h> 
#include <InterViews/transformer.h> 
#include <Unidraw/Graphic/grblock.h> 
#include <Unidraw/Graphic/pspaint.h> 
#include <Unidraw/Graphic/picture.h> 
#include <Unidraw/Graphic/polygons.h> 
#include <InterViews/button.h> 
#include <InterViews/frame.h> 
#include <InterViews/streditor.h> 
#include "Mainmenu-core.h" 
#include <IV-2_6/_enter.h>


#ifndef Mainmenu_core_func
#define Mainmenu_core_func
typedef void (Mainmenu_core::*Mainmenu_core_Func)();
#endif

class Mainmenu_core_Button : public ButtonState {
public:
    Mainmenu_core_Button(int, Mainmenu_core* = nil, Mainmenu_core_Func = nil);
    virtual void Notify();
    void SetCoreClass(Mainmenu_core*);
    void SetCoreFunc(Mainmenu_core_Func);
private:
    Mainmenu_core_Func _func;
    Mainmenu_core* _coreclass;
};

Mainmenu_core_Button::Mainmenu_core_Button(
    int i, Mainmenu_core* coreclass, Mainmenu_core_Func func
) : ButtonState(i) {
    _coreclass = coreclass;
    _func = func;
}

void Mainmenu_core_Button::SetCoreClass(Mainmenu_core* core) {
    _coreclass = core;
}

void Mainmenu_core_Button::SetCoreFunc(Mainmenu_core_Func func) {
    _func = func;
}

void Mainmenu_core_Button::Notify() {
    ButtonState::Notify();
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

class Mainmenu_core_HGlue : public HGlue {
public:
    Mainmenu_core_HGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

class Mainmenu_core_VGlue : public VGlue {
public:
    Mainmenu_core_VGlue(const char*, int, int, int);
protected:
    virtual void Resize();
};

Mainmenu_core_HGlue::Mainmenu_core_HGlue (
    const char* name, int nat, int shr, int str) : HGlue(name, nat, shr, str) {}

void Mainmenu_core_HGlue::Resize () {
    HGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

Mainmenu_core_VGlue::Mainmenu_core_VGlue (
    const char* name, int nat, int shr, int str) : VGlue(name, nat, shr, str) {}

void Mainmenu_core_VGlue::Resize () {
    VGlue::Resize();
    canvas->SetBackground(output->GetBgColor());
}

#ifndef Mainmenu_core_func
#define Mainmenu_core_func
typedef void (Mainmenu_core::*Mainmenu_core_Func)();
#endif

class Mainmenu_core_Menu : public MenuItem {
public:
    Mainmenu_core_Menu(const char*, Interactor*);
    virtual void Do();
    void SetCoreClass(Mainmenu_core*);
    void SetCoreFunc(Mainmenu_core_Func);
private:
    Mainmenu_core_Func _func;
    Mainmenu_core* _coreclass;
};

Mainmenu_core_Menu::Mainmenu_core_Menu(
    const char* instance, Interactor* i
) : MenuItem(instance, i) {
    _func = nil;
    _coreclass = nil;
}

void Mainmenu_core_Menu::SetCoreClass(Mainmenu_core* core) {
    _coreclass = core;
}

void Mainmenu_core_Menu::SetCoreFunc(Mainmenu_core_Func func) {
    _func = func;
}

void Mainmenu_core_Menu::Do() {
    if (_func != nil) {
        (_coreclass->*_func)();
    }
}

Mainmenu_core::Mainmenu_core(const char* name) {
    SetClassName("Mainmenu");
    SetInstance(name);
    if (input != nil) {
        input->Unreference();
    }
    input = allEvents;
    input->Reference();
    Insert(Interior());
}

Interactor* Mainmenu_core::Interior() {
    graphBS = new Mainmenu_core_Button(0);
    ((Mainmenu_core_Button*)graphBS)->SetCoreClass(this);
    ((Mainmenu_core_Button*)graphBS)->SetCoreFunc(&Mainmenu_core::grapher);
    sampleBS = new Mainmenu_core_Button(0);
    ((Mainmenu_core_Button*)sampleBS)->SetCoreClass(this);
    ((Mainmenu_core_Button*)sampleBS)->SetCoreFunc(&Mainmenu_core::sampler);
    analBS = new Mainmenu_core_Button(0);
    ((Mainmenu_core_Button*)analBS)->SetCoreClass(this);
    ((Mainmenu_core_Button*)analBS)->SetCoreFunc(&Mainmenu_core::anal);
    editordevice = new Mainmenu_core_Button(0);
    ((Mainmenu_core_Button*)editordevice)->SetCoreClass(this);
    ((Mainmenu_core_Button*)editordevice)->SetCoreFunc(&Mainmenu_core::device);
    VBox* _VBox_63 = new VBox();
    Message* _Message_18 = new Message("_instance_5", "Network Packet Data Tool, By James Jegers", Center, 0, 0, 0);
    HBorder* _HBorder_23 = new HBorder("_instance_10", 2 );
    HBox* _HBox_76 = new HBox();
    quitButton = new Mainmenu_core_Menu("_instance_48", new Message("Quit", Left, 2, 1000000, 0));
    ((Mainmenu_core_Menu*)quitButton)->SetCoreClass(this);
    ((Mainmenu_core_Menu*)quitButton)->SetCoreFunc(&Mainmenu_core::Quit);
    PulldownMenu* _PulldownMenu_71 = new PulldownMenu("_instance_46", new Message("Control", Center, 2, 0, 0));
    _PulldownMenu_71->Include(quitButton);
    HGlue* _HGlue_74 = new Mainmenu_core_HGlue("_instance_49", 232, 232, 1000000);
    _HBox_76->Insert(_PulldownMenu_71);
    _HBox_76->Insert(_HGlue_74);
    HBorder* _HBorder_24 = new HBorder("_instance_11", 2 );
    HBox* _HBox_111 = new HBox();
    HGlue* _HGlue_109 = new Mainmenu_core_HGlue("_instance_78", 11, 11, 1000000);
    VBox* _VBox_104 = new VBox();
    PSBrush* brush_65535_0 = new PSBrush(65535, 0);
    PSColor* _000000 = new PSColor(0, 0, 0, "_000000");
    PSColor* _ffffff = new PSColor(1, 1, 1, "_ffffff");
    PSPattern* pat_1_000000 = new PSPattern(0, (float)1);
    GraphicBlock* _GraphicBlock_90 = new GraphicBlock("_instance_63", nil, 0, Center);
    SF_Rect* _SF_Rect_89;
    {
        _SF_Rect_89 = new SF_Rect(326, 565, 412, 650);
        _SF_Rect_89->FillBg(1);
        _SF_Rect_89->SetBrush(brush_65535_0);
        _SF_Rect_89->SetColors(_000000, _ffffff);
        _SF_Rect_89->SetPattern(pat_1_000000);
        _SF_Rect_89->SetTransformer(new Transformer(1, 0, 0, 1, 0, 0));
    }
    Picture* _GraphicBlock_90_pic = new Picture;
    _GraphicBlock_90_pic->Append(_SF_Rect_89);
    _GraphicBlock_90->SetGraphic(_GraphicBlock_90_pic);
    VBox* _VBox_57 = new VBox();
    graphButton = new PushButton("_instance_0", "Graphical Display", graphBS, 1);
    _VBox_57->Insert(graphButton);
    VGlue* _VGlue_101 = new Mainmenu_core_VGlue("_instance_70", 20, 24, 0);
    _VBox_104->Insert(_GraphicBlock_90);
    _VBox_104->Insert(_VBox_57);
    _VBox_104->Insert(_VGlue_101);
    VBorder* _VBorder_86 = new VBorder("_instance_61", 2 );
    VBox* _VBox_105 = new VBox();
    GraphicBlock* _GraphicBlock_93 = new GraphicBlock("_instance_64", nil, 0, Center);
    SF_Rect* _SF_Rect_92;
    {
        _SF_Rect_92 = new SF_Rect(450, 568, 556, 637);
        _SF_Rect_92->FillBg(1);
        _SF_Rect_92->SetBrush(brush_65535_0);
        _SF_Rect_92->SetColors(_000000, _ffffff);
        _SF_Rect_92->SetPattern(pat_1_000000);
        _SF_Rect_92->SetTransformer(new Transformer(1, 0, 0, 1, 0, 0));
    }
    Picture* _GraphicBlock_93_pic = new Picture;
    _GraphicBlock_93_pic->Append(_SF_Rect_92);
    _GraphicBlock_93->SetGraphic(_GraphicBlock_93_pic);
    VBox* _VBox_58 = new VBox();
    sampleButton = new PushButton("_instance_1", "Sample Packets", sampleBS, 1);
    _VBox_58->Insert(sampleButton);
    VGlue* _VGlue_102 = new Mainmenu_core_VGlue("_instance_71", 20, 31, 0);
    _VBox_105->Insert(_GraphicBlock_93);
    _VBox_105->Insert(_VBox_58);
    _VBox_105->Insert(_VGlue_102);
    VBorder* _VBorder_87 = new VBorder("_instance_62", 2 );
    VBox* _VBox_106 = new VBox();
    GraphicBlock* _GraphicBlock_96 = new GraphicBlock("_instance_65", nil, 0, Center);
    SF_Rect* _SF_Rect_95;
    {
        _SF_Rect_95 = new SF_Rect(622, 559, 726, 637);
        _SF_Rect_95->FillBg(1);
        _SF_Rect_95->SetBrush(brush_65535_0);
        _SF_Rect_95->SetColors(_000000, _ffffff);
        _SF_Rect_95->SetPattern(pat_1_000000);
        _SF_Rect_95->SetTransformer(new Transformer(1, 0, 0, 1, 0, 0));
    }
    Picture* _GraphicBlock_96_pic = new Picture;
    _GraphicBlock_96_pic->Append(_SF_Rect_95);
    _GraphicBlock_96->SetGraphic(_GraphicBlock_96_pic);
    VBox* _VBox_59 = new VBox();
    analButton = new PushButton("_instance_2", "Analyze Packets", analBS, 1);
    _VBox_59->Insert(analButton);
    VGlue* _VGlue_103 = new Mainmenu_core_VGlue("_instance_72", 20, 22, 0);
    _VBox_106->Insert(_GraphicBlock_96);
    _VBox_106->Insert(_VBox_59);
    _VBox_106->Insert(_VGlue_103);
    HGlue* _HGlue_110 = new Mainmenu_core_HGlue("_instance_79", 53, 53, 1000000);
    _HBox_111->Insert(_HGlue_109);
    _HBox_111->Insert(_VBox_104);
    _HBox_111->Insert(_VBorder_86);
    _HBox_111->Insert(_VBox_105);
    _HBox_111->Insert(_VBorder_87);
    _HBox_111->Insert(_VBox_106);
    _HBox_111->Insert(_HGlue_110);
    HBorder* _HBorder_34 = new HBorder("_instance_15", 2 );
    HBox* _HBox_62 = new HBox();
    Message* _Message_41 = new Message("_instance_22", "Device:(ie, pf0, pf1 or ec0, el0)", Center, 0, 0, 0);
    Frame* _Frame_82 = new Frame("_instance_57", nil, 2);
    editorButton = new StringEditor("_instance_56", editordevice, "           ");
    editorButton->Message("");
    _Frame_82->Insert(editorButton);
    HGlue* _HGlue_67 = new Mainmenu_core_HGlue("_instance_42", 32, 32, 1000000);
    _HBox_62->Insert(_Message_41);
    _HBox_62->Insert(_Frame_82);
    _HBox_62->Insert(_HGlue_67);
    HBorder* _HBorder_108 = new HBorder("_instance_77", 2 );
    _VBox_63->Insert(_Message_18);
    _VBox_63->Insert(_HBorder_23);
    _VBox_63->Insert(_HBox_76);
    _VBox_63->Insert(_HBorder_24);
    _VBox_63->Insert(_HBox_111);
    _VBox_63->Insert(_HBorder_34);
    _VBox_63->Insert(_HBox_62);
    _VBox_63->Insert(_HBorder_108);
    return _VBox_63;
};

void Mainmenu_core::Quit() {}
void Mainmenu_core::grapher() {}
void Mainmenu_core::sampler() {}
void Mainmenu_core::anal() {}
void Mainmenu_core::device() {}

