/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */

#include <sys/types.h>
#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>

void quit_callback(w, client_data, call_data)
Widget w;
caddr_t client_data, call_data;
{
  exit(0);
}

void
quit_button(parent)
Widget parent;
{
Arg wargs[1];
Widget w;

	XtSetArg(wargs[0], XtNlabel, "Quit");
	w = XtCreateManagedWidget("quit", commandWidgetClass, parent, 
								wargs, 1);
	XtAddCallback(w, XtNcallback, quit_callback, NULL);
}

static char*
makecmd(pgm, args)
char *pgm;
char *args[];
{
	char *cmd = (char *) malloc(10240);
	char *ptr;
	for (ptr = cmd; *pgm; *ptr++ = *pgm++)
		continue;
	*ptr++ = ' ';
	if (args)
		for(pgm = *args++; pgm; pgm = *args++) {
		   for (; *pgm; *ptr++ = *pgm++)
		       continue;
 		   *ptr++ = ' ';
		}
	*ptr++ = '&';
	*ptr = '\0';
/*	fprintf(stderr, "%s\n", cmd);*/
	return cmd;
}

/*  
 *  Callable procedure that does a system call to run
 *  the other programs
 */
void
call(w, program)
Widget w;
char *program;
{
	system(program);
}

void 
graph_button(parent, args)
Widget parent;
char *args[];
{
Arg wargs[1];
Widget graph;

	XtSetArg(wargs[0], XtNlabel, "Graphic Display");
	graph = XtCreateManagedWidget("graph", commandWidgetClass, 
				parent, wargs,1);
	XtAddCallback(graph, XtNcallback, call, makecmd("xnetgraph", args) );
}

void
sample_button(parent, args)
Widget parent;
char *args[];
{
Arg wargs[1];
Widget graph;

	XtSetArg(wargs[0], XtNlabel, "Sample Packets");
	graph = XtCreateManagedWidget("sample", commandWidgetClass, 
				parent, wargs,1);
	XtAddCallback(graph, XtNcallback, call, makecmd("xnetsampler", args));
}

void
analyse_button(parent, args)
Widget parent;
char *args[];
{
Arg wargs[1];
Widget graph;

	XtSetArg(wargs[0], XtNlabel, "Analyze Packets");
	graph = XtCreateManagedWidget("analyse", commandWidgetClass, 
				parent, wargs,1);
	XtAddCallback(graph, XtNcallback, call, makecmd("xnetanal", args) );
}
