/*
 * Copyright (C) 1992  Board of Regents of the University of Wisconsin
 * on behalf of the Department of Electrical Engineering and Computer
 * Science, University of Wisconsin-Milwaukee, Milwaukee, WI 53201.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * The programs in this directory were developed by software engineering
 * teams as part of the course "Introduction to Software Engineering"
 * under the supervision of Professor G. Davida.
 *
 * Please send all changes, enhancements, and other comments about this
 * software to
 *
 *     		soft-eng@cs.uwm.edu
 *
 *			or
 *		
 *		Software Engineering Coordinator
 *		Computer Science
 *   		Department of EECS
 *		University of Wisconsin - Milwaukee
 *		Milwaukee, WI  53201
 *		414-229-4677
 */

#include <sys/types.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

extern void start_sample_data();
extern void stop_sample_data();

static void quit_callback(w, client_data, call_data)
Widget w;
caddr_t client_data;
caddr_t call_data;
{
    stop_sample_data();
    exit(0);
}

quit_button(parent)
Widget parent;
{
    Arg wargs[1];
    Widget w;

    XtSetArg(wargs[0], XtNlabel, "Quit");
    w = XtCreateManagedWidget("quit", commandWidgetClass, parent, wargs, 1);
    XtAddCallback(w, XtNcallback, quit_callback, NULL);
}

/*
 **  Start button **
 */

start_button(parent)
Widget parent;
{
    Arg wargs[1];
    Widget start;

    XtSetArg(wargs[0], XtNlabel, "Start");
    start = XtCreateManagedWidget("start", commandWidgetClass, parent,wargs,1);
    XtAddCallback(start, XtNcallback, start_sample_data , NULL);
}

/* Stop button */
stop_button(parent)
Widget parent;
{
    Arg wargs[1];
    Widget stop;

    XtSetArg(wargs[0], XtNlabel, "Stop");
    stop = XtCreateManagedWidget("stop", commandWidgetClass, parent,wargs,1);
    XtAddCallback(stop, XtNcallback, stop_sample_data , NULL);
}

Widget edit_one_line(name, parent)
char *name;
Widget parent;
{
   Arg Args[5];
   XtSetArg(Args[0], XtNeditType, "edit");
   XtSetArg(Args[1], XtNstring, "");

   return(XtCreateManagedWidget(name, asciiTextWidgetClass, parent, Args, 2) );
}

char *getlabel(wid)
Widget wid;
{
    Arg Args[1];
    char *string;

    XtSetArg(Args[0], XtNstring, &string);
    XtGetValues(wid, Args, 1);
    return(string);
}

